#include "ds18b20.h"

// Variable tampon
bit bit_var;
char crc_byte;


/****** Reset du DS18b20 et test de prsence *****/
bit DS18B20_reset()
{
	TRIS_DQ = 0;	//DQ en sortie
	DQ_PIN = 0;
	__delay_us(500);
	TRIS_DQ = 1;	// DQ en entre
	__delay_us(70);
	bit_var = !DQ_PIN;
	__delay_us(410);
	return bit_var ;
}

/**** Ecriture d'un bit *****/
void DS18B20_write_bit(char octet)
{
	bit_var = octet;
	TRIS_DQ = 0;	//DQ en sortie
	DQ_PIN = 0;
	if(bit_var)
		__delay_us(1);
	else
		__delay_us(60);		
	TRIS_DQ = 1;	//On relche le port
	if(bit_var)
		__delay_us(64);
	else
		__delay_us(10);
}

/**** Lecture d'un bit *****/
bit DS18B20_read_bit()
{
	TRIS_DQ = 0;	//DQ en sortie
	DQ_PIN = 0;
	__delay_us(1);
	TRIS_DQ = 1;	//On relche le port
	__delay_us(7);	//On attend que le DS18B20 prenne la main
	if(DQ_PIN==1)
	{
		bit_var = 1;
	}
	else
	{
		bit_var = 0;
	}
	__delay_us(55);
	return bit_var;
}

/**** Ecriture d'une commande *****/
void DS18B20_write_commande(char octet)
{
		for (char i = 0; i < 8;i++)
	{
		DS18B20_write_bit(octet >> i);
		__delay_us(1);
	}
}

/********* Lecture octet *********/
char DS18B20_read_octet()
{
	unsigned char i,octet;
	octet=0;
	for(char i = 0; i < 8;i++)
	{
		if(DS18B20_read_bit())	// On lit un bit
			octet+= 1 << i;
		__delay_us(1);
	}
	return octet;
}

/******* Lecture de la temprature *******/
int DS18B20_read_temp()
{	
	int temp=0;
	char tampon;
	int i;
	if(!DS18B20_reset()) //Initialisation des commandes
		return ERROR;
	DS18B20_write_commande(0xCC);
	DS18B20_write_commande(0x44);
	__delay_ms(150);
	__delay_ms(150);
	__delay_ms(150);
	__delay_ms(150);
	__delay_ms(200);
	__delay_ms(200);
	if(!DS18B20_reset()) //Initialisation des commandes
		return ERROR;
	DS18B20_write_commande(0xCC);
	DS18B20_write_commande(0xBE);

	crc_byte=0;
	tampon=DS18B20_read_octet();
	CRC_Check (tampon);
	temp=0;
	temp+= tampon;
	tampon=DS18B20_read_octet();
	CRC_Check (tampon);
	temp+= tampon<<8;

	for( i=0;i<7;i++)
	{
		tampon=DS18B20_read_octet();
		CRC_Check (tampon);
	}
	if(crc_byte==0)
		return temp;
	else
		return ERROR;
}

/********** test du CRC **********/
char CRC_Check (char data) {
   char bit_cnt;
   char tmp1;
      
    for (bit_cnt = 8; bit_cnt != 0; bit_cnt--) 
	{
      tmp1 =(data ^ crc_byte) &1;
      data >>=1;       /* shift right one bit */
      crc_byte >>=1;       /* shift right one bit */
      if (tmp1 !=0)
        crc_byte ^=0x8c;      /* x8+x5+x4+1 shifted one bit right */
    }
     return (crc_byte);
} 