/**************************************************************
Auteur: Christophe HAMON
Site Web: www.chriss-creation.fr
Date: 18/12/10
***************************************************************/
#include <htc.h>
__CONFIG(CPD & PROTECT & BORDIS & MCLRDIS & PWRTEN & INTIO & WDTDIS );
#include "ds18b20.h"

#define SORTIE GPIO0  // Sortie du relais

/*** Seuil pour l'histeresis sur la mesure de la priode du signal (s) ***/
#define SEUIL_BAS 500  
#define SEUIL_HAUT 800

/*** Seuil de temprature ***/
//Seuil = Temprature dsir * 16
//Ici seuil fix  2C
#define SEUIL_TEMP 32



volatile unsigned char pluie;
volatile unsigned int TempsEcoule;

/*
Sous programme d'interruption
Calcul la priode du signal du NE555 et indique s'il pleut ou non
*/
void interrupt SP_inter(void)
{
   if (TMR1IF)
    {
		pluie=0;
		TMR1ON=0;// Arrt du timer
    }
	if (INTF)
    {
		INTF=0;
		if(TMR1ON==1)
		{
			TMR1ON=0;// Arrt du timer
			TempsEcoule=0;
			TempsEcoule+=TMR1H;
			TempsEcoule<<=8;
			TempsEcoule&=0xFF00;
			TempsEcoule+=TMR1L;
			if(SORTIE == 0 && TempsEcoule > SEUIL_HAUT)
			{
				pluie = 1;
			}
			else if (SORTIE == 1 && TempsEcoule < SEUIL_BAS)
			{
				pluie = 0;
			}
			TMR1H=0;
			TMR1L=0;
		}
		else
		{
			TMR1ON=1;// Dmarrage du timer
		}
    }
    return;
} 

/***  Configuration du PIC16F675 ***/
void config(void) {
	CMCON=0x07; //Comparator Off
  	TRISIO = 0x04; //Input sur GP2
	GPIO=0;
   	ANSEL = 0x00;
	INTF=0;
	INTCON = 0xD0; //GIE activs + interruption sur GP2
	TMR1IF=0;
	TMR1IE=1; //Interruption TMR1 activ
	TMR1ON=1;// Dmarrage du timer
}

/*** Programme principal ***/
void main() 
{
	int temperature;
	config();
	SORTIE=0;	
   	while(1) 
	{ // infinite loop
		TMR1ON=0;// Arrt du timer
		INTE=0;// Arrt INT sur GP2
		GIE=0;		//On arrte les interruptions le temps de la capture de temp
		temperature = DS18B20_read_temp();
		TMR1H=0;
		TMR1L=0;
		TMR1IF=0;
		INTF=0;
		INTE=1;
		GIE=1;		//Redemarrage des interruptions
		__delay_ms(500);
		__delay_ms(500);

		//Si TC<2C et TC valide et pluie alors il neige
		if (temperature < SEUIL_TEMP & temperature!=ERROR & pluie) 
			SORTIE=1;	//On active le relais
		else if (temperature!=ERROR | pluie == 0)
			SORTIE=0;
	}
}

